package com.jiuqi.mde;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.mde.MDEDimension;
import com.jiuqi.util.NumberFormatManager;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class MDEDimensionSet implements Cloneable, Comparable {
  private String dimensionNames = null;
  
  private ArrayList dimensions = new ArrayList(2);
  
  private Map nameSearch = new HashMap<Object, Object>(10);
  
  public static final int SCR_EQUAL = 0;
  
  public static final int SCR_MORE = 1;
  
  public static final int SCR_LESS = 2;
  
  public static final int SCR_LESS_AND_MORE = 3;
  
  public final int size() {
    return this.dimensions.size();
  }
  
  public final MDEDimension get(int index) {
    return this.dimensions.get(index);
  }
  
  public final MDEDimension find(String name) {
    Integer index = (Integer)this.nameSearch.get(name);
    return (index != null) ? this.dimensions.get(index.intValue()) : null;
  }
  
  public final void clear() {
    this.dimensions.clear();
    this.nameSearch.clear();
    this.dimensionNames = null;
  }
  
  private final int findOrder(String order) {
    int start = 0;
    int stop = this.dimensions.size() - 1;
    int flag = -1;
    while (start <= stop) {
      int middle = start + stop + 1 >> 1;
      flag = order.compareTo(((MDEDimension)this.dimensions.get(middle)).order);
      if (flag > 0) {
        start = middle + 1;
        continue;
      } 
      if (flag < 0) {
        stop = middle - 1;
        continue;
      } 
      start = middle;
      if (start == stop)
        break; 
    } 
    return (flag == 0) ? start : (-start - 1);
  }
  
  public final void add(MDEDimension dimension) {
    if (!this.nameSearch.containsKey(dimension.name)) {
      int index = findOrder(dimension.order);
      if (index < 0) {
        index = -1 - index;
      } else {
        index++;
      } 
      this.dimensionNames = null;
      this.dimensions.add(index, dimension);
      for (int i = index, count = this.dimensions.size(); i < count; i++)
        this.nameSearch.put(((MDEDimension)this.dimensions.get(i)).name, NumberFormatManager.getInt(i)); 
    } 
  }
  
  public final void add(com.jiuqi.mde.MDEDimensionSet dimensions) {
    for (int i = 0, count = dimensions.size(); i < count; i++)
      add(dimensions.get(i)); 
  }
  
  public final void remove(MDEDimension dimension) {
    Integer index = (Integer)this.nameSearch.get(dimension.name);
    if (index != null) {
      this.dimensionNames = null;
      this.nameSearch.remove(dimension.name);
      this.dimensions.remove(index.intValue());
      for (int i = index.intValue(), count = this.dimensions.size(); i < count; i++)
        this.nameSearch.put(((MDEDimension)this.dimensions.get(i)).name, NumberFormatManager.getInt(i)); 
    } 
  }
  
  public final int indexOf(MDEDimension dimension) {
    Integer index = (Integer)this.nameSearch.get(dimension.name);
    return (index != null) ? index.intValue() : -1;
  }
  
  public final int indexOf(String name) {
    Integer index = (Integer)this.nameSearch.get(name);
    return (index != null) ? index.intValue() : -1;
  }
  
  public final boolean contains(MDEDimension dimension) {
    return (this.nameSearch.get(dimension.name) != null);
  }
  
  public final boolean contains(String name) {
    return (this.nameSearch.get(name) != null);
  }
  
  public final MDEDimension findByFieldName(String fieldName) {
    for (int i = 0, count = this.dimensions.size(); i < count; i++) {
      MDEDimension dimension = this.dimensions.get(i);
      if (fieldName.equals(dimension.fieldName))
        return dimension; 
    } 
    return null;
  }
  
  public final boolean hasOrder() {
    return (find("顺序号") != null);
  }
  
  public Object clone() {
    com.jiuqi.mde.MDEDimensionSet result = new com.jiuqi.mde.MDEDimensionSet();
    result.add(this);
    return result;
  }
  
  public final int compareTo(Object o) {
    if (this == o)
      return 0; 
    if (o == null)
      return 1; 
    if (this == null)
      return -1; 
    if (o instanceof com.jiuqi.mde.MDEDimensionSet)
      return toString().compareTo(((com.jiuqi.mde.MDEDimensionSet)o).toString()); 
    return hashCode() - o.hashCode();
  }
  
  public final boolean equals(Object o) {
    return (compareTo(o) == 0);
  }
  
  public final int collectCompare(com.jiuqi.mde.MDEDimensionSet another) {
    if (this == another)
      return 0; 
    if (another == null)
      return 1; 
    if (this == null)
      return -1; 
    int result = 0;
    int matched = 0;
    for (int i = 0, count = this.dimensions.size(); i < count; i++) {
      MDEDimension dimension = this.dimensions.get(i);
      if (another.contains(dimension)) {
        matched++;
      } else {
        result |= 0x1;
      } 
    } 
    if (matched < another.size())
      result |= 0x2; 
    return result;
  }
  
  public final boolean contains(com.jiuqi.mde.MDEDimensionSet another) {
    int cr = collectCompare(another);
    return !(cr != 0 && cr != 1);
  }
  
  public boolean lessAndMore(com.jiuqi.mde.MDEDimensionSet another) {
    int cr = collectCompare(another);
    return (cr == 3);
  }
  
  public final String toString() {
    if (this.dimensionNames == null) {
      StringBuffer result = new StringBuffer(64);
      boolean needComma = false;
      for (int i = 0, count = this.dimensions.size(); i < count; i++) {
        MDEDimension dimension = this.dimensions.get(i);
        if (needComma)
          result.append(", "); 
        result.append(dimension.name);
      } 
      this.dimensionNames = result.toString();
    } 
    return this.dimensionNames;
  }
}
